#include<iostream> 
using namespace std; 

void changeCurrentPlayer(char& currentPlayer);
bool playerWon(int moves);
bool gameOver(int xMoves, int oMoves);
void displayGameBoard(int xMoves, int oMoves);
void getMove(int& xMoves, int& oMoves, char currentPlayer);

void main() 
{
	int xMoves = 0;
	int oMoves = 0;
	char currentPlayer = 'X';

	while(!gameOver(xMoves,oMoves))
	{
		displayGameBoard(xMoves, oMoves);
		getMove(xMoves,oMoves, currentPlayer);
		changeCurrentPlayer(currentPlayer);
	}
	displayGameBoard(xMoves, oMoves);
	if(playerWon(xMoves))
	{
		cout << "X Wins!" << endl;
	}
	else if(playerWon(oMoves))
	{
		cout << "O Wins!" << endl;
	}
	else
	{
		cout << "CAT Wins!  :)" << endl;
	}
}
void getMove(int& xMoves, int& oMoves, char currentPlayer)
{
	int move;
	int movePower;
	do
	{
		cout <<  currentPlayer << "'s move? ";	
		cin >> move;
		movePower = pow(2,move);
	}
	while(((xMoves & movePower) == movePower) ||
		((oMoves & movePower) == movePower) ||
		move > 9 ||  move < 1);

	if(currentPlayer == 'X')
	{
		xMoves = xMoves + movePower;
	}
	else
	{
		oMoves = oMoves + movePower;
	}
}


void displayGameBoard(int xMoves, int oMoves)
{
	for(int i = 2,  j = 1; i <= 512; i = i * 2, j++)
	{
		if((xMoves & i) == i)
		{
			cout << "X";
		}
		else if((oMoves & i) == i)
		{
			cout << "O";
		}
		else
		{
			cout << j;
		}
		if(j == 3 || j == 6)
		{
			cout << "\n-----\n";
		}
		else if(j != 9)
		{
			cout << "|";
		}
		
	}
	cout << endl << endl << endl;
}

bool gameOver(int xMoves, int oMoves)
{
	bool result = false;
	if(playerWon(xMoves) ||
		playerWon(oMoves) ||
		xMoves + oMoves == 1022) 
	{
		result = true;
	}
	return result;
}

bool playerWon(int moves)
{
	bool result = false;
	if(((moves & 146 ) == 146) ||
		((moves & 292 ) == 292) ||
		((moves & 584 ) == 584) ||
		((moves & 14 ) == 14) ||
		((moves & 112 ) == 112) ||
		((moves & 896 ) == 896) ||
		((moves & 546 ) == 546) ||
		((moves & 168 ) == 168) )
	{
		result = true;
	}

	return result;
}

void changeCurrentPlayer(char& currentPlayer)
{
	if(currentPlayer == 'X')
	{
		currentPlayer = 'O';
	}
	else
	{
		currentPlayer = 'X';
	}
}
